/* jshint ignore:start */

/* jshint ignore:end */

define('dummy/app', ['exports', 'ember', 'ember/resolver', 'ember/load-initializers', 'dummy/config/environment'], function (exports, Ember, Resolver, loadInitializers, config) {

  'use strict';

  var App;

  Ember['default'].MODEL_FACTORY_INJECTIONS = true;

  App = Ember['default'].Application.extend({
    modulePrefix: config['default'].modulePrefix,
    podModulePrefix: config['default'].podModulePrefix,
    Resolver: Resolver['default']
  });

  loadInitializers['default'](App, config['default'].modulePrefix);

  exports['default'] = App;

});
define('dummy/controllers/things', ['exports', 'ember', 'ella-sparse-array-controller/controllers/sparse-array'], function (exports, Ember, EmberellaSparseArray) {

  'use strict';

  var ThingsController;

  ThingsController = EmberellaSparseArray['default'].extend({
    test: 'Hello, World'
  });

  exports['default'] = ThingsController;

});
define('dummy/ella-sparse-array-controller/tests/modules/ella-sparse-array-controller/controllers/sparse-array', ['exports', 'ember'], function (exports, Ember) {

  'use strict';

  var EmberellaSparseArray,
      get,
      set,
      slice = [].slice;

  get = Ember['default'].get;

  set = Ember['default'].set;

  /*
  @module emberella
  @submodule emberella-controllers
   */

  /*
    `EmberellaSparseArray` is a variation on an
    `Ember.ArrayController` that allows content to be lazily loaded from the
    persistence layer.

    @class EmberellaSparseArray
    @extends Ember.ArrayProxy
   */

  EmberellaSparseArray = Ember['default'].ArrayProxy.extend(Ember['default'].ControllerMixin, {

    /*
      @private
    
      Stash a reference to the original content object.
    
      @property _content
      @type {Mixed}
      @default null
     */
    _content: null,

    /*
      @private
    
      Stash the potential total number of items as reported by the
      persistence layer.
    
      @property _length
      @type {Integer}
      @default null
     */
    _length: null,

    /*
      @property isSelectable
      @type Boolean
      @default true
      @final
     */
    isSparseArrayController: true,

    /*
      The number of items to fetch together in a single request. Essentially,
      the "page size" of each query.
    
      @property rangeSize
      @type {Integer}
      @default 1
     */
    rangeSize: 1,

    /*
      Flag to indicate if this controller should attempt to fetch data.
    
      @property shouldRequestObjects
      @type {Boolean}
      @default true
     */
    shouldRequestObjects: true,

    /*
      Alias to `content` property. Override to customize the behavior of
      content referencing.
    
      @property sparseContent
     */
    sparseContent: Ember['default'].computed.alias('content'),

    /*
      The total number of potential items in the sparse array. If the length is
      unknown, requesting this property will cause the controller to try to fetch
      the total length from the persistence layer.
    
      @property length
      @type {Integer}
      @default 0
      @readOnly
     */
    length: Ember['default'].computed(function () {
      var ret;
      ret = get(this, '_length');
      if (Ember['default'].isEmpty(ret)) {
        this.requestLength();
      }
      return get(this, '_length') || 0;
    }).property('_length').readOnly(),

    /*
      True if this controller instance is attempting to fetch its length.
    
      @property isRequestingLength
      @type {Boolean}
      @default false
     */
    isRequestingLength: null,

    /*
      True if this controller instance is attempting to fetch its length.
    
      @property isUpdating
      @type {Boolean}
      @default false
     */
    isUpdating: Ember['default'].computed(function () {
      return !!get(this, 'isRequestingLength');
    }).property('isRequestingLength'),
    init: function init() {
      this._TMP_OBJECT = {
        isSparseArrayItem: true,
        isStale: true
      };
      this._TMP_PROVIDE_ARRAY = [];
      this._TMP_PROVIDE_RANGE = {
        length: 1
      };
      this._TMP_RANGE = {};
      return this._super();
    },

    /*
      Return the content in array format.
    
      @method toArray
      @return {Array}
     */
    toArray: function toArray() {
      var sparseContent;
      sparseContent = get(this, 'sparseContent');
      if (!sparseContent) {
        return Ember['default'].A();
      }
      return sparseContent.toArray();
    },

    /*
      Check the content to see if a valid, non-stale object is available at the
      provided index.
    
      @method isObjectAt
      @param {Integer} idx The index to check for object existence
      @return {Boolean}
     */
    isObjectAt: function isObjectAt(idx) {
      var result;
      result = this.objectAt(idx, true);
      return !!(result && result.isStale !== true);
    },

    /*
      Get the data from the specified index.
    
      If an object is found at a given index, it will be returned immediately.
    
      Otherwise, a "stale" placeholder object will be returned and a new remote
      query to fetch the data for the given index will be created.
    
      @method objectAt
      @param {Integer} idx The index to obtain content for
      @param {Boolean} dontFetch Won't obtain remote data if `true`
      @return {Object}
     */
    objectAt: function objectAt(idx, dontFetch) {
      var ref, result;
      idx = parseInt(idx, 10);
      if (isNaN(idx) || idx < 0 || idx >= get(this, 'length')) {
        return void 0;
      }
      result = (ref = this._super(idx)) != null ? ref : this.insertSparseArrayItem(idx);
      if (result && result.isStale !== true) {
        return result;
      }
      return this.requestObjectAt(idx, dontFetch);
    },

    /*
      Fetches data at the specified index. If `rangeSize` is greater than 1, this
      method will also retrieve adjacent items to form a "page" of results.
    
      @method requestObjectAt
      @param {Integer} idx The index to fetch content for
      @param {Boolean} dontFetch Won't obtain remote data if `true`
      @return {Object|Null} A placeholder object or null if content is empty
     */
    requestObjectAt: function requestObjectAt(idx, dontFetch) {
      var content, i, j, k, placeholders, range, rangeSize, ref, ref1, ref2, results, start;
      if (dontFetch == null) {
        dontFetch = !get(this, 'shouldRequestObjects');
      }
      if (dontFetch) {
        return (ref = get(this, 'sparseContent')[idx]) != null ? ref : this.insertSparseArrayItem(idx);
      }
      content = get(this, 'content');
      rangeSize = parseInt(get(this, 'rangeSize'), 10) || 1;
      if (content == null) {
        return null;
      }
      start = Math.floor(idx / rangeSize) * rangeSize;
      start = Math.max(start, 0);
      placeholders = Math.min(start + rangeSize, get(this, 'length'));
      this.insertSparseArrayItems((function () {
        results = [];
        for (var j = start; start <= placeholders ? j < placeholders : j > placeholders; start <= placeholders ? j++ : j--) {
          results.push(j);
        }
        return results;
      }).apply(this));
      if (this.didRequestRange !== Ember['default'].K) {
        range = this._TMP_RANGE;
        range.start = start;
        range.length = rangeSize;
        this._didRequestRange(range);
      } else {
        for (i = k = ref1 = start, ref2 = rangeSize; ref1 <= ref2 ? k < ref2 : k > ref2; i = ref1 <= ref2 ? ++k : --k) {
          this._didRequestIndex(i);
        }
      }
      return get(this, 'sparseContent')[idx];
    },

    /*
      Fetches data regarding the total number of objects in the
      persistence layer.
    
      @method requestLength
      @return {Integer} The current known length
     */
    requestLength: function requestLength() {
      var len;
      len = get(this, '_length');
      if (!(this.didRequestLength === Ember['default'].K || get(this, 'isRequestingLength'))) {
        set(this, 'isRequestingLength', true);
        this._didRequestLength();
        return len;
      }
      return get(this, '_content.length');
    },

    /*
      Empty the sparse array.
    
      @method reset
      @chainable
     */
    reset: function reset() {
      var len;
      this.beginPropertyChanges();
      len = get(this, '_length');
      this._clearSparseContent();
      set(this, '_length', len);
      this.endPropertyChanges();
      return this;
    },

    /*
      Uncache the item at the specified index.
    
      @method unset
      @param {Integer} idx The index to unset
      @chainable
     */
    unset: function unset(idx) {
      var sparseContent;
      if (idx == null) {
        return this;
      }
      sparseContent = get(this, 'sparseContent');
      sparseContent[idx] = void 0;
      return this;
    },

    /*
      Remove the item at the specified index.
    
      @method removeObject
      @param {Mixed} obj The object to remove from the content
      @chainable
     */
    removeObject: function removeObject(obj) {
      var shouldRequestObjects;
      shouldRequestObjects = get(this, 'shouldRequestObjects');
      this.disableRequests();
      this._super(obj);
      if (shouldRequestObjects) {
        this.enableRequests();
      }
      return this;
    },

    /*
      Enable data fetching.
    
      @method enableRequests
      @chainable
     */
    enableRequests: function enableRequests() {
      set(this, 'shouldRequestObjects', true);
      return this;
    },

    /*
      Disable data fetching.
    
      @method disableRequests
      @chainable
     */
    disableRequests: function disableRequests() {
      set(this, 'shouldRequestObjects', false);
      return this;
    },

    /*
      Insert a placeholder object at the specified index.
    
      @method insertSparseArrayItem
      @param {Integer} idx Where to inject a placeholder
      @param {Boolean} force If true, placeholder replaces existing content
      @return {Object}
     */
    insertSparseArrayItem: function insertSparseArrayItem(idx, force) {
      var proxy, sparseContent;
      if (force == null) {
        force = false;
      }
      sparseContent = get(this, 'sparseContent');
      proxy = Ember['default'].copy(this._TMP_OBJECT);
      proxy.contentIndex = idx;
      if (force || sparseContent[idx] == null) {
        sparseContent[idx] = proxy;
      }
      return sparseContent[idx];
    },

    /*
      Insert placeholder objects at the specified indexes.
    
      @method insertSparseArrayItems
      @param {Integer|Array} idx Multiple indexes
      @chainable
     */
    insertSparseArrayItems: function insertSparseArrayItems() {
      var i, idx, j, len1, ref;
      idx = 1 <= arguments.length ? slice.call(arguments, 0) : [];
      ref = [].concat.apply([], idx);
      for (j = 0, len1 = ref.length; j < len1; j++) {
        i = ref[j];
        this.insertSparseArrayItem(i);
      }
      return this;
    },

    /*
      Async callback to provide total number of objects available to this
      controller stored in the persistence layer.
    
      @method provideLength
      @param {Integer} length The total number of available objects
      @chainable
     */
    provideLength: function provideLength(length) {
      set(this, '_length', length);
      set(this, 'isRequestingLength', false);
      return this;
    },

    /*
      Async callback to provide objects in a specific range.
    
      @method provideObjectsInRange
      @param {Object} [range] A range object
        @param {Integer} [range.start]
          The index at which objects should be inserted into the content array
        @param {Integer} [range.length]
          The number of items to replace with the updated data
      @param {Array} array The data to inject into the sparse array
      @chainable
     */
    provideObjectsInRange: function provideObjectsInRange(range, array) {
      var sparseContent;
      sparseContent = get(this, 'sparseContent');
      sparseContent.replace(range.start, range.length, array);
      return this;
    },

    /*
      Async callback to provide an object at a specific index.
    
      Ultimately, this method calls `provideObjectsInRange`. Override
      `provideObjectsInRange` to inject custom behavior.
    
      @method provideObjectAtIndex
      @param {Integer} idx The index to insert data at
      @param {Object} obj The object to insert
      @chainable
     */
    provideObjectAtIndex: function provideObjectAtIndex(idx, obj) {
      var array, range;
      array = this._TMP_PROVIDE_ARRAY;
      range = this._TMP_PROVIDE_RANGE;
      array[0] = obj;
      range.start = idx;
      return this.provideObjectsInRange(range, array);
    },

    /*
      Hook for responding to impending updates to the content array. Override to
      add custom handling for array updates.
    
      @method contentArrayWillChange
      @param {Array} array The array instance being updated
      @param {Integer} idx The index where changes applied
      @param {Integer} removedCount
      @param {Integer} addedCount
     */
    contentArrayWillChange: function contentArrayWillChange(array, idx, removedCount, addedCount) {
      return this;
    },

    /*
      Hook for responding to updates to the content array. Override to
      add custom handling for array updates.
    
      @method contentArrayWillChange
      @param {Array} array The array instance being updated
      @param {Integer} idx The index where changes applied
      @param {Integer} removedCount
      @param {Integer} addedCount
     */
    contentArrayDidChange: function contentArrayDidChange(array, idx, removedCount, addedCount) {
      return this;
    },

    /*
      @private
    
      Override Ember's `_contentWillChange` to observe `_content`.
    
      @method _contentWillChange
     */
    _contentWillChange: Ember['default'].beforeObserver(function () {
      return this._super();
    }, '_content'),

    /*
      @private
    
      Override Ember's `_contentDidChange` to observe `_content` and `content`.
    
      @method _contentDidChange
     */
    _contentDidChange: Ember['default'].observer(function () {
      return this._super();
    }, 'content', '_content'),

    /*
      @private
    
      Move any array set to the `content` property to the `_content` property.
    
      This allows `content` to be used for referencing the sparse array while
      retaining a reference to the originally provided content object.
    
      @method _setupContent
      @return {Array} The sparse array
     */
    _setupContent: function _setupContent() {
      var _content, controller, ref, sparseContent;
      controller = this;
      _content = get(controller, 'content');
      if (_content && _content.isSparseArray) {
        return;
      }
      if (_content) {
        _content.addArrayObserver(controller, {
          willChange: 'contentArrayWillChange',
          didChange: 'contentArrayDidChange'
        });
      }
      sparseContent = Ember['default'].A((ref = _content && _content.slice()) != null ? ref : []);
      sparseContent.isSparseArray = true;
      set(controller, '_content', _content);
      set(controller, 'sparseContent', sparseContent);
      return sparseContent;
    },

    /*
      @private
    
      Remove observers from `_content`.
    
      @method _teardownContent
      @return null
     */
    _teardownContent: function _teardownContent() {
      var _content, controller;
      controller = this;
      _content = get(controller, '_content');
      if (_content) {
        _content.removeArrayObserver(controller, {
          willChange: 'contentArrayWillChange',
          didChange: 'contentArrayDidChange'
        });
      }
      return null;
    },

    /*
      @private
    
      Set reported length to `content.total` if it changes.
    
      @method _contentTotalChanged
      @chainable
     */
    _contentTotalChanged: Ember['default'].observer(function () {
      set(this, '_length', get(this, 'content.total'));
      return this;
    }, 'content.total'),

    /*
      Hook for responding to the sparse array being replaced with a new
      array instance. Override to add custom handling.
    
      @method sparseContentWillChange
      @param {Object} self
     */
    sparseContentWillChange: Ember['default'].K,

    /*
      Hook for responding to the sparse array being replaced with a new
      array instance. Override to add custom handling.
    
      @method sparseContentDidChange
      @param {Object} self
     */
    sparseContentDidChange: Ember['default'].K,

    /*
      Hook for injecting custom behavior when an item in the sparse array gets
      replaced with new data.
    
      @method sparseContentDidChange
      @param {Object} item The previous value
      @param {Object} addedObject The new value
     */
    didReplaceSparseArrayItem: Ember['default'].K,

    /*
      Hook for responding to impending updates to the sparse array. Extend to
      add custom handling for array updates.
    
      @method sparseContentArrayWillChange
      @param {Array} array The array instance being updated
      @param {Integer} idx The index where changes applied
      @param {Integer} removedCount
      @param {Integer} addedCount
     */
    sparseContentArrayWillChange: function sparseContentArrayWillChange(array, idx, removedCount, addedCount) {
      this._PREVIOUS_SPARSE_CONTENT = array.slice(idx, idx + removedCount);
      return this;
    },

    /*
      Hook for responding to updates to the sparse array. Extend to
      add custom handling for array updates.
    
      @method sparseContentArrayDidChange
      @param {Array} array The array instance being updated
      @param {Integer} idx The index where changes applied
      @param {Integer} removedCount
      @param {Integer} addedCount
     */
    sparseContentArrayDidChange: function sparseContentArrayDidChange(array, idx, removedCount, addedCount) {
      var addedObjects, delta, i, item, j, len1, ref, removedObjects;
      removedObjects = (ref = this._PREVIOUS_SPARSE_CONTENT) != null ? ref : Ember['default'].A();
      addedObjects = array.slice(idx, idx + addedCount);
      delta = ((addedObjects != null ? addedObjects.length : void 0) || 0) - ((removedObjects != null ? removedObjects.length : void 0) || 0);
      set(this, '_length', get(this, '_length') + delta);
      for (i = j = 0, len1 = removedObjects.length; j < len1; i = ++j) {
        item = removedObjects[i];
        if (item && item.isSparseArrayItem) {
          this.didReplaceSparseArrayItem(item, addedObjects[i]);
        }
      }
      this._PREVIOUS_SPARSE_CONTENT = null;
      return this;
    },

    /*
      @private
    
      Sparse array change handler.
    
      @method _sparseContentWillChange
     */
    _sparseContentWillChange: Ember['default'].beforeObserver(function () {
      var len, sparseContent;
      sparseContent = get(this, 'sparseContent');
      len = sparseContent ? get(sparseContent, 'length') : 0;
      this.sparseContentArrayWillChange(this, 0, len, void 0);
      this.sparseContentWillChange(this);
      return this._teardownSparseContent(sparseContent);
    }, 'sparseContent'),

    /*
      @private
    
      Sparse array change handler.
    
      @method _sparseContentDidChange
     */
    _sparseContentDidChange: Ember['default'].observer(function () {
      var len, sparseContent;
      sparseContent = get(this, 'sparseContent');
      len = sparseContent ? get(sparseContent, 'length') : 0;
      this._setupSparseContent(sparseContent);
      this.sparseContentDidChange(this);
      return this.sparseContentArrayDidChange(this, 0, void 0, len);
    }, 'sparseContent'),

    /*
      @private
    
      Remove change observing on sparse array.
    
      @method _teardownSparseContent
     */
    _teardownSparseContent: function _teardownSparseContent() {
      var sparseContent;
      this._clearSparseContent();
      sparseContent = get(this, 'sparseContent');
      if (sparseContent) {
        return sparseContent.removeArrayObserver(this, {
          willChange: 'sparseContentArrayWillChange',
          didChange: 'sparseContentArrayDidChange'
        });
      }
    },

    /*
      @private
    
      Add change observing on sparse array.
    
      @method _setupSparseContent
     */
    _setupSparseContent: function _setupSparseContent() {
      var sparseContent;
      sparseContent = get(this, 'sparseContent');
      if (sparseContent) {
        sparseContent.addArrayObserver(this, {
          willChange: 'sparseContentArrayWillChange',
          didChange: 'sparseContentArrayDidChange'
        });
      }
      return this._lengthDidChange();
    },

    /*
      @private
    
      Set the sparse array's length to the controller's length.
    
      @method _lengthDidChange
     */
    _lengthDidChange: Ember['default'].observer(function () {
      var length, ref, sparseContent;
      length = (ref = get(this, 'length')) != null ? ref : 0;
      sparseContent = get(this, 'sparseContent');
      if (Ember['default'].isArray(sparseContent) && sparseContent.isSparseArray && sparseContent.length !== length) {
        return sparseContent.length = length;
      }
    }, 'length'),

    /*
      @private
    
      Empty the sparse array.
    
      @method _clearSparseContent
     */
    _clearSparseContent: function _clearSparseContent() {
      var sparseContent;
      sparseContent = get(this, 'sparseContent');
      if (sparseContent && sparseContent.isSparseArray) {
        sparseContent.clear();
      }
      return this;
    },

    /*
      Called before controller destruction.
    
      @method willDestroy
     */
    willDestroy: function willDestroy() {
      this._super();
      return this._teardownSparseContent();
    },

    /*
      Hook for single object requests. Override this method to enable this
      controller to obtain a single persisted object.
    
      If the request is successful, insert the fetched object into the sparse
      array using the `provideObjectAtIndex` method.
    
      @method didRequestIndex
      @param {Integer} idx
     */
    didRequestIndex: Ember['default'].K,

    /*
      Hook for range requests. Override this method to enable this controller
      to obtain a page of persisted data.
    
      If the request is successful, insert the fetched objects into the sparse
      array using the `provideObjectsInRange` method.
    
      @method didRequestRange
      @param {Object} [range] A range object
        @param {Integer} [range.start]
          The index to fetch
        @param {Integer} [range.length]
          The number of items to fetch
     */
    didRequestRange: Ember['default'].K,

    /*
      Hook for initiating requests for the total number of objects available to
      this controller in the persistence layer. Override this method to enable
      this controller to obtain its length.
    
      If the request is successful, set the length of this sparse array
      controller using the `provideLength` method.
    
      @method didRequestLength
     */
    didRequestLength: Ember['default'].K,

    /*
      @private
    
      Prevents the controller from continuously attempting to fetch data for
      objects that are already in the process of being fetched.
    
      @method _markSparseArrayItemInProgress
      @param {Integer} idx The index of the object to place into a loading state
     */
    _markSparseArrayItemInProgress: function _markSparseArrayItemInProgress(idx) {
      var item, sparseContent;
      sparseContent = get(this, 'sparseContent');
      if (!(sparseContent && Ember['default'].typeOf(sparseContent === 'array'))) {
        return;
      }
      item = sparseContent[idx];
      if (item && item.isStale) {
        item.isStale = false;
      }
      return item;
    },

    /*
      @private
    
      Prepare to fetch a page of data from the persistence layer.
    
      @method _didRequestRange
      @param {Object} [range] A range object
        @param {Integer} [range.start]
          The index to fetch
        @param {Integer} [range.length]
          The number of items to fetch
     */
    _didRequestRange: function _didRequestRange(range) {
      var idx, j, ref, ref1;
      for (idx = j = ref = range.start, ref1 = range.start + range.length; ref <= ref1 ? j < ref1 : j > ref1; idx = ref <= ref1 ? ++j : --j) {
        this._markSparseArrayItemInProgress(idx);
      }
      return this.didRequestRange(range);
    },

    /*
      @private
    
      Prepare to fetch a single object from the persistence layer.
    
      @method _didRequestIndex
      @param {Integer} idx
     */
    _didRequestIndex: function _didRequestIndex(idx) {
      this._markSparseArrayItemInProgress(idx);
      return this.didRequestIndex(idx);
    },

    /*
      @private
    
      Prepare to fetch the total number of available objects from the
      persistence layer.
    
      @method _didRequestLength
     */
    _didRequestLength: function _didRequestLength() {
      return this.didRequestLength();
    }
  });

  exports['default'] = EmberellaSparseArray;

});
define('dummy/initializers/app-version', ['exports', 'dummy/config/environment', 'ember'], function (exports, config, Ember) {

  'use strict';

  var classify = Ember['default'].String.classify;
  var registered = false;

  exports['default'] = {
    name: 'App Version',
    initialize: function initialize(container, application) {
      if (!registered) {
        var appName = classify(application.toString());
        Ember['default'].libraries.register(appName, config['default'].APP.version);
        registered = true;
      }
    }
  };

});
define('dummy/initializers/export-application-global', ['exports', 'ember', 'dummy/config/environment'], function (exports, Ember, config) {

  'use strict';

  exports.initialize = initialize;

  function initialize(container, application) {
    var classifiedName = Ember['default'].String.classify(config['default'].modulePrefix);

    if (config['default'].exportApplicationGlobal && !window[classifiedName]) {
      window[classifiedName] = application;
    }
  }

  ;

  exports['default'] = {
    name: 'export-application-global',

    initialize: initialize
  };

});
define('dummy/router', ['exports', 'ember', 'dummy/config/environment'], function (exports, Ember, config) {

  'use strict';

  var Router;

  Router = Ember['default'].Router.extend({
    location: config['default'].locationType
  });

  Router.map(function () {
    this.route('index', {
      path: '/'
    });
    return this.route('things');
  });

  exports['default'] = Router;

});
define('dummy/routes/index', ['exports', 'ember'], function (exports, Ember) {

  'use strict';

  var IndexRoute;

  IndexRoute = Ember['default'].Route.extend({
    redirect: function redirect() {
      return this.transitionTo('things');
    }
  });

  exports['default'] = IndexRoute;

});
define('dummy/routes/things', ['exports', 'ember'], function (exports, Ember) {

  'use strict';

  var ThingsRoute;

  ThingsRoute = Ember['default'].Route.extend({
    setupController: function setupController(controller, model) {
      return controller.set('errorMessage', null);
    }
  });

  exports['default'] = ThingsRoute;

});
define('dummy/templates/application', ['exports'], function (exports) {

  'use strict';

  exports['default'] = Ember.HTMLBars.template((function() {
    return {
      isHTMLBars: true,
      revision: "Ember@1.11.1",
      blockParams: 0,
      cachedFragment: null,
      hasRendered: false,
      build: function build(dom) {
        var el0 = dom.createDocumentFragment();
        var el1 = dom.createElement("h2");
        dom.setAttribute(el1,"id","title");
        var el2 = dom.createTextNode("Welcome to Ember.js");
        dom.appendChild(el1, el2);
        dom.appendChild(el0, el1);
        var el1 = dom.createTextNode("\n\n");
        dom.appendChild(el0, el1);
        var el1 = dom.createComment("");
        dom.appendChild(el0, el1);
        var el1 = dom.createTextNode("\n");
        dom.appendChild(el0, el1);
        return el0;
      },
      render: function render(context, env, contextualElement) {
        var dom = env.dom;
        var hooks = env.hooks, content = hooks.content;
        dom.detectNamespace(contextualElement);
        var fragment;
        if (env.useFragmentCache && dom.canClone) {
          if (this.cachedFragment === null) {
            fragment = this.build(dom);
            if (this.hasRendered) {
              this.cachedFragment = fragment;
            } else {
              this.hasRendered = true;
            }
          }
          if (this.cachedFragment) {
            fragment = dom.cloneNode(this.cachedFragment, true);
          }
        } else {
          fragment = this.build(dom);
        }
        var morph0 = dom.createMorphAt(fragment,2,2,contextualElement);
        content(env, morph0, context, "outlet");
        return fragment;
      }
    };
  }()));

});
define('dummy/templates/index', ['exports'], function (exports) {

  'use strict';

  exports['default'] = Ember.HTMLBars.template((function() {
    return {
      isHTMLBars: true,
      revision: "Ember@1.11.1",
      blockParams: 0,
      cachedFragment: null,
      hasRendered: false,
      build: function build(dom) {
        var el0 = dom.createDocumentFragment();
        return el0;
      },
      render: function render(context, env, contextualElement) {
        var dom = env.dom;
        dom.detectNamespace(contextualElement);
        var fragment;
        if (env.useFragmentCache && dom.canClone) {
          if (this.cachedFragment === null) {
            fragment = this.build(dom);
            if (this.hasRendered) {
              this.cachedFragment = fragment;
            } else {
              this.hasRendered = true;
            }
          }
          if (this.cachedFragment) {
            fragment = dom.cloneNode(this.cachedFragment, true);
          }
        } else {
          fragment = this.build(dom);
        }
        return fragment;
      }
    };
  }()));

});
define('dummy/templates/things', ['exports'], function (exports) {

  'use strict';

  exports['default'] = Ember.HTMLBars.template((function() {
    return {
      isHTMLBars: true,
      revision: "Ember@1.11.1",
      blockParams: 0,
      cachedFragment: null,
      hasRendered: false,
      build: function build(dom) {
        var el0 = dom.createDocumentFragment();
        var el1 = dom.createComment("");
        dom.appendChild(el0, el1);
        var el1 = dom.createTextNode("\n");
        dom.appendChild(el0, el1);
        return el0;
      },
      render: function render(context, env, contextualElement) {
        var dom = env.dom;
        var hooks = env.hooks, content = hooks.content;
        dom.detectNamespace(contextualElement);
        var fragment;
        if (env.useFragmentCache && dom.canClone) {
          if (this.cachedFragment === null) {
            fragment = this.build(dom);
            if (this.hasRendered) {
              this.cachedFragment = fragment;
            } else {
              this.hasRendered = true;
            }
          }
          if (this.cachedFragment) {
            fragment = dom.cloneNode(this.cachedFragment, true);
          }
        } else {
          fragment = this.build(dom);
        }
        var morph0 = dom.createMorphAt(fragment,0,0,contextualElement);
        dom.insertBoundary(fragment, 0);
        content(env, morph0, context, "test");
        return fragment;
      }
    };
  }()));

});
define('dummy/tests/helpers/resolver', ['exports', 'ember/resolver', 'dummy/config/environment'], function (exports, Resolver, config) {

  'use strict';

  var resolver = Resolver['default'].create();

  resolver.namespace = {
    modulePrefix: config['default'].modulePrefix,
    podModulePrefix: config['default'].podModulePrefix
  };

  exports['default'] = resolver;

});
define('dummy/tests/helpers/resolver.jshint', function () {

  'use strict';

  module('JSHint - helpers');
  test('helpers/resolver.js should pass jshint', function() { 
    ok(true, 'helpers/resolver.js should pass jshint.'); 
  });

});
define('dummy/tests/helpers/start-app', ['exports', 'ember', 'dummy/app', 'dummy/router', 'dummy/config/environment'], function (exports, Ember, Application, Router, config) {

  'use strict';



  exports['default'] = startApp;
  function startApp(attrs) {
    var application;

    var attributes = Ember['default'].merge({}, config['default'].APP);
    attributes = Ember['default'].merge(attributes, attrs); // use defaults, but you can override;

    Ember['default'].run(function () {
      application = Application['default'].create(attributes);
      application.setupForTesting();
      application.injectTestHelpers();
    });

    return application;
  }

});
define('dummy/tests/helpers/start-app.jshint', function () {

  'use strict';

  module('JSHint - helpers');
  test('helpers/start-app.js should pass jshint', function() { 
    ok(true, 'helpers/start-app.js should pass jshint.'); 
  });

});
define('dummy/tests/test-helper', ['dummy/tests/helpers/resolver', 'ember-qunit'], function (resolver, ember_qunit) {

	'use strict';

	ember_qunit.setResolver(resolver['default']);

});
define('dummy/tests/test-helper.jshint', function () {

  'use strict';

  module('JSHint - .');
  test('test-helper.js should pass jshint', function() { 
    ok(true, 'test-helper.js should pass jshint.'); 
  });

});
/* jshint ignore:start */

/* jshint ignore:end */

/* jshint ignore:start */

define('dummy/config/environment', ['ember'], function(Ember) {
  var prefix = 'dummy';
/* jshint ignore:start */

try {
  var metaName = prefix + '/config/environment';
  var rawConfig = Ember['default'].$('meta[name="' + metaName + '"]').attr('content');
  var config = JSON.parse(unescape(rawConfig));

  return { 'default': config };
}
catch(err) {
  throw new Error('Could not read config from meta tag with name "' + metaName + '".');
}

/* jshint ignore:end */

});

if (runningTests) {
  require("dummy/tests/test-helper");
} else {
  require("dummy/app")["default"].create({"name":"ella-sparse-array-controller","version":"v0.0.1"});
}

/* jshint ignore:end */
//# sourceMappingURL=dummy.map